package cn.com.qmth.scancentral.service;

import cn.com.qmth.scancentral.bean.ExamConfigDomain;
import cn.com.qmth.scancentral.bean.ImportExamDomain;
import cn.com.qmth.scancentral.bean.User;
import cn.com.qmth.scancentral.entity.ExamEntity;
import cn.com.qmth.scancentral.vo.ExamConfigVo;
import cn.com.qmth.scancentral.vo.ExamInitVo;
import cn.com.qmth.scancentral.vo.ExamRemoteVo;
import cn.com.qmth.scancentral.vo.ExamVo;
import cn.com.qmth.scancentral.vo.checkimage.RatioVo;
import cn.com.qmth.scancentral.vo.examinfo.ExamInfoVo;
import cn.com.qmth.scancentral.vo.examinfo.ExamQuery;
import cn.com.qmth.scancentral.vo.scanexaminfo.ScanExamInfoVo;
import cn.com.qmth.scancentral.vo.scanexamlist.ScanExamListVo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.boot.core.collection.PageResult;
import com.qmth.boot.mybatis.query.BaseQuery;

import java.util.List;

public interface ExamService extends IService<ExamEntity> {

    PageResult<ExamVo> pageQuery(ExamQuery query, User user);

    List<ExamEntity> listEnable();

    ExamInfoVo getExamInfoVo(Long id, User accessUser);

    List<ScanExamListVo> getScanExamList();

    PageResult<ExamRemoteVo> listRemote(BaseQuery<?> query, User accessUser);

    ScanExamInfoVo getScanExamInfo(Long id, User accessUser);

    ExamConfigVo config(User user, ExamConfigDomain domain);

    Double syncProgress(User user, Long examId);

    void sync(User user, Long examId);

    ExamInitVo init(User user, ExamConfigDomain domain);

    ExamEntity save(ImportExamDomain exam);

    RatioVo updateRatio(Long examId, Double ratio);

    void updateDataSyncTime(Long examId);

    void updateCardSyncTime(Long examId);

    void updateExamNumberFillCount(Long examId, Integer examNumberFillCount);

    ExamEntity updateEnableSyncVerify(User user,Long examId, Boolean enableSyncVerify);

}
